#include <windows.h>   
#include <math.h>   

const float MISSING = (float) 3.4e38;


_declspec (dllexport) void MyRSIunfiltered ( float *Close, long RSILength, long N, float *output )
{	double CU, CD,MyRSI;
	long i, count;

	MyRSI = MISSING;
	for ( i=0; i<N; i++ )
	{	if ( i >= RSILength )
		{	//Accumulate "Closes Up" and "Closes Down"
			CU = 0;
			CD = 0;
			for ( count = 0; count<RSILength; count++ )
			{	if ( Close[i-count] - Close[i-(count + 1)] > 0 ) CU = CU + Close[i-count] - Close[i-(count + 1)];
				if ( Close[i-count] - Close[i-(count + 1)] < 0 ) CD = CD + Close[i-(count + 1)] - Close[i-count];
			}
			if ( CU + CD != 0 ) 
				MyRSI = (CU - CD) / (CU + CD);
			else
				MyRSI = MISSING;
		}
		output[i] = (float) MyRSI;
	}
}


_declspec (dllexport) void NET ( float *Input, long NETLength, long N, float *output )
{	double Num, Denom, NET, diff, Sign;
	double *X, *Y;
	long i, count, K;
	
	X = malloc ( (NETLength + 1) * sizeof(double) );
	Y = malloc ( (NETLength + 1) * sizeof(double) );

	//Noise Elimination Technology (NET)
	NET = MISSING;
	for ( i=0; i<N; i++ )
	{	if ( i >= NETLength )
		{
			for ( count = 1; count <= NETLength; count++ )
			{	X[count] = Input[i-(count - 1)];
				Y[count] = -count;
			}

			Num = 0;
			for ( count = 2; count <= NETLength; count++ )
				for ( K = 1; K <= count - 1; K++)
				{	diff = X[count] - X[K];
					Sign = (diff > 0) ? 1 : ((diff < 0) ? -1 : 0);
					Num = Num - Sign;
				}
			Denom = .5 * NETLength * (NETLength - 1);

			NET = Num / Denom;
		}
		output[i] = (float) NET;
	}

	free(X);
	free(Y);
}


